"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var teleport_component_generator_1 = require("@teleporthq/teleport-component-generator");
var teleport_component_generator_vue_1 = require("@teleporthq/teleport-component-generator-vue");
var teleport_plugin_vue_app_routing_1 = __importDefault(require("@teleporthq/teleport-plugin-vue-app-routing"));
var teleport_plugin_import_statements_1 = __importDefault(require("@teleporthq/teleport-plugin-import-statements"));
var teleport_postprocessor_prettier_js_1 = __importDefault(require("@teleporthq/teleport-postprocessor-prettier-js"));
var teleport_postprocessor_prettier_html_1 = __importDefault(require("@teleporthq/teleport-postprocessor-prettier-html"));
var project_utils_1 = require("@teleporthq/teleport-shared/lib/utils/project-utils");
var constants_1 = require("@teleporthq/teleport-shared/lib/constants");
var vue_project_mapping_json_1 = __importDefault(require("./vue-project-mapping.json"));
exports.createRouterFile = function (root) { return __awaiter(_this, void 0, void 0, function () {
    var vueRouterGenerator, _a, files, dependencies, routerFile;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                vueRouterGenerator = teleport_component_generator_1.createGenerator();
                vueRouterGenerator.addPlugin(teleport_plugin_vue_app_routing_1.default);
                vueRouterGenerator.addPlugin(teleport_plugin_import_statements_1.default);
                vueRouterGenerator.addPostProcessor(teleport_postprocessor_prettier_js_1.default);
                // Routes are defined in router.js
                root.meta = root.meta || {};
                root.meta.fileName = 'router';
                return [4 /*yield*/, vueRouterGenerator.generateComponent(root)];
            case 1:
                _a = _b.sent(), files = _a.files, dependencies = _a.dependencies;
                routerFile = files[0];
                return [2 /*return*/, { routerFile: routerFile, dependencies: dependencies }];
        }
    });
}); };
exports.createHtmlEntryFile = function (projectUIDL, options) {
    var _a;
    var htmlFileGenerator = teleport_component_generator_1.createGenerator();
    htmlFileGenerator.addPostProcessor(teleport_postprocessor_prettier_html_1.default);
    var fileHAST = project_utils_1.createHtmlIndexFile(projectUIDL, options);
    var chunks = (_a = {},
        _a[constants_1.FILE_TYPE.HTML] = [
            {
                name: 'doctype',
                type: 'string',
                content: '<!DOCTYPE>',
                linkAfter: [],
            },
            {
                name: 'html-node',
                type: 'html',
                content: fileHAST,
                linkAfter: ['doctype'],
            },
        ],
        _a);
    // html file is generated as index.html
    var htmlFilename = 'index';
    var htmlFile = htmlFileGenerator.linkCodeChunks(chunks, htmlFilename)[0];
    return htmlFile;
};
exports.createVueGenerator = function (options) {
    var vueGenerator = teleport_component_generator_vue_1.createVueComponentGenerator({
        mapping: vue_project_mapping_json_1.default,
    });
    if (options.customMapping) {
        vueGenerator.addMapping(options.customMapping);
    }
    return vueGenerator;
};
//# sourceMappingURL=component-generators.js.map